#include <iostream>

using namespace std;
int a[1000001]={0};
int svap(int i,int j)
{
    int temp=a[i];
    a[i]=a[j];
    a[j]=temp;
}
int main()
{
    int n;
    cin>>n;
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
    }
    if(n==2)
    {
        svap(0,1);
    }
    else
        {
    int maks=-1;
    int maks_index=-1;
    int l_index=-1;
    int r_index=-1;
        for(int i=n-1;i>=0;i--)
        {
            if(a[i]>maks){
                maks=a[i];
                maks_index=i;
                continue;
            }

            if(a[i]<maks)
            {
                l_index=i;
                r_index=maks_index;
            }
        }
        if(l_index==-1)
            {

            }
        svap(l_index,r_index);
    }
    for(int i=0;i<n;i++)
    {
        cout<<a[i]<<" ";
    }

    return 0;
}